/***************************************************************
 * Name:      wxprvniMain.cpp
 * Purpose:   Code for Application Frame
 * Author:    VF (V)
 * Created:   2020-06-02
 * Copyright: VF (V)
 * License:
 **************************************************************/

#include "wxprvniMain.h"
#include <wx/msgdlg.h>

//(*InternalHeaders(wxprvniFrame)
#include <wx/intl.h>
#include <wx/string.h>
//*)

//helper functions
enum wxbuildinfoformat {
    short_f, long_f };

wxString wxbuildinfo(wxbuildinfoformat format)
{
    wxString wxbuild(wxVERSION_STRING);

    if (format == long_f )
    {
#if defined(__WXMSW__)
        wxbuild << _T("-Windows");
#elif defined(__UNIX__)
        wxbuild << _T("-Linux");
#endif

#if wxUSE_UNICODE
        wxbuild << _T("-Unicode build");
#else
        wxbuild << _T("-ANSI build");
#endif // wxUSE_UNICODE
    }

    return wxbuild;
}

//(*IdInit(wxprvniFrame)
const long wxprvniFrame::ID_STATICTEXT1 = wxNewId();
const long wxprvniFrame::ID_TEXTCTRL1 = wxNewId();
const long wxprvniFrame::ID_CHECKBOX1 = wxNewId();
const long wxprvniFrame::ID_BUTTON1 = wxNewId();
const long wxprvniFrame::ID_BUTTON2 = wxNewId();
const long wxprvniFrame::idMenuQuit = wxNewId();
const long wxprvniFrame::idMenuAbout = wxNewId();
const long wxprvniFrame::ID_STATUSBAR1 = wxNewId();
//*)

BEGIN_EVENT_TABLE(wxprvniFrame,wxFrame)
    //(*EventTable(wxprvniFrame)
    //*)
END_EVENT_TABLE()

wxprvniFrame::wxprvniFrame(wxWindow* parent,wxWindowID id)
{
    //(*Initialize(wxprvniFrame)
    wxGridSizer* GridSizer1;
    wxGridSizer* GridSizer2;
    wxGridSizer* GridSizer3;
    wxMenu* Menu1;
    wxMenu* Menu2;
    wxMenuBar* MenuBar1;
    wxMenuItem* MenuItem1;
    wxMenuItem* MenuItem2;

    Create(parent, id, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
    GridSizer1 = new wxGridSizer(3, 1, 0, 0);
    GridSizer2 = new wxGridSizer(1, 2, 0, 0);
    StaticText1 = new wxStaticText(this, ID_STATICTEXT1, _T("Zadej své jméno:"), wxDefaultPosition, wxDefaultSize, 0, _T("ID_STATICTEXT1"));
    GridSizer2->Add(StaticText1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    TextCtrl1 = new wxTextCtrl(this, ID_TEXTCTRL1, wxEmptyString, wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    GridSizer2->Add(TextCtrl1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    GridSizer1->Add(GridSizer2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Zena_zaskrtnuti = new wxCheckBox(this, ID_CHECKBOX1, _T("Žena"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CHECKBOX1"));
    Zena_zaskrtnuti->SetValue(false);
    GridSizer1->Add(Zena_zaskrtnuti, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    GridSizer3 = new wxGridSizer(1, 2, 0, 0);
    Button1 = new wxButton(this, ID_BUTTON1, _T("Klikni si"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON1"));
    GridSizer3->Add(Button1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    Button2 = new wxButton(this, ID_BUTTON2, _T("Pryč"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON2"));
    GridSizer3->Add(Button2, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    GridSizer1->Add(GridSizer3, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
    SetSizer(GridSizer1);
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, idMenuQuit, _T("Konec\tAlt-F4"), _T("Ukončí aplikaci"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&File"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, idMenuAbout, _T("O programu\tF1"), _T("Zobrazí informaci o aplikaci"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _T("Nápověda"));
    SetMenuBar(MenuBar1);
    StatusBar1 = new wxStatusBar(this, ID_STATUSBAR1, 0, _T("ID_STATUSBAR1"));
    int __wxStatusBarWidths_1[1] = { -1 };
    int __wxStatusBarStyles_1[1] = { wxSB_NORMAL };
    StatusBar1->SetFieldsCount(1,__wxStatusBarWidths_1);
    StatusBar1->SetStatusStyles(1,__wxStatusBarStyles_1);
    SetStatusBar(StatusBar1);
    GridSizer1->Fit(this);
    GridSizer1->SetSizeHints(this);

    Connect(ID_BUTTON1,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxprvniFrame::OnButton1Click);
    Connect(ID_BUTTON2,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&wxprvniFrame::OnQuit);
    Connect(idMenuQuit,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxprvniFrame::OnQuit);
    Connect(idMenuAbout,wxEVT_COMMAND_MENU_SELECTED,(wxObjectEventFunction)&wxprvniFrame::OnAbout);
    //*)
}

wxprvniFrame::~wxprvniFrame()
{
    //(*Destroy(wxprvniFrame)
    //*)
}

void wxprvniFrame::OnQuit(wxCommandEvent& event)
{
    Close();
}

void wxprvniFrame::OnAbout(wxCommandEvent& event)
{
    wxString msg = wxbuildinfo(long_f);
    wxMessageBox(msg, _("Welcome to..."));
}

void wxprvniFrame::OnButton1Click(wxCommandEvent& event)
{
  if (TextCtrl1->GetLineLength(0)==0) { wxMessageBox(_T("Nezadal jsi žádné jméno"),_T("Upozornění")); return; }
  wxString text;
  if (Zena_zaskrtnuti->IsChecked()==true) text = _T("Vážená paní ");
  else text = _T("Vážený pan ");
  text += TextCtrl1->GetLineText(0);
  wxMessageBox(text,_T("Oslovení"));
}
